package org.dive4elements.river.artifacts.model.minfo;

import gnu.trove.TDoubleArrayList;


public class BedDiffYearResult
extends BedDifferencesResult
{

    protected TDoubleArrayList bedHeights;
    protected TDoubleArrayList dataGap;
    protected TDoubleArrayList morphWidth;
    protected int start;
    protected int end;

    public BedDiffYearResult () {
        super();
        this.bedHeights = new TDoubleArrayList();
        this.dataGap = new TDoubleArrayList();
        this.morphWidth = new TDoubleArrayList();
        this.start = -1;
        this.end = -1;
    }

    public BedDiffYearResult(
        TDoubleArrayList kms,
        TDoubleArrayList differences,
        TDoubleArrayList heights1,
        TDoubleArrayList heights2,
        TDoubleArrayList morphWidth,
        TDoubleArrayList bedHeights,
        TDoubleArrayList dataGap,
        int start,
        int end
    ) {
        super(kms, differences, heights1, heights2);
        this.bedHeights = bedHeights;
        this.dataGap = dataGap;
        this.morphWidth = morphWidth;
        this.start = start;
        this.end = end;
    }

    public TDoubleArrayList getBedHeights() {
        return this.bedHeights;
    }

    public TDoubleArrayList getDataGap() {
        return this.dataGap;
    }

    public TDoubleArrayList getMorphWidth() {
        return this.morphWidth;
    }

    public int getStart() {
        return this.start;
    }

    public void setStart(int value) {
        this.start = value;
    }

    public void setEnd(int value) {
        this.end = value;
    }

    public int getEnd() {
        return this.end;
    }

    public void addMorphWidth(double value) {
        this.morphWidth.add(value);
    }

    public void addBedHeights(double value) {
        this.bedHeights.add(value);
    }

    public double[][] getMorphWidthData() {
        return new double[][] {
            kms.toNativeArray(),
            morphWidth.toNativeArray()
        };
    }

    public double[][] getHeightPerYearData() {
        return new double[][] {
            kms.toNativeArray(),
            bedHeights.toNativeArray()
        };
    }
}
